#ifndef __euler_scheme_RNM2__
#ifdef __GNUG__
#pragma interface
#endif
#define __euler_scheme_RNM2__

#include <vector>
#include <cassert>
#include "RefCounter.hpp"
#include "RNM.hpp"



using namespace std;

class Euler_Scheme
{
private:
  
  vector<vector<double> >S_nodes,S_steps;
  vector<double> grid_t;
  vector<int> change_grid;
  double rate (double) { return 0.04; }
  double vol(double,double) { return 0.2; }
  double eps;
 
 
protected:

public: 
  Euler_Scheme(const  vector<vector<double> > &g_grid_S, const  vector<vector<double> > &g_S_steps, vector<double> & g_grid_t, vector<int> & g_change_grid)
    :S_nodes(g_grid_S),S_steps(g_S_steps), grid_t(g_grid_t), change_grid(g_change_grid)
  {eps=1e-9;};
																	       
  void energy( vector< KN<double> >& P, double & energy);
  void Time_Step(int i,  vector<KN<double> >  &P,int verbose=0);
  void build_rhs(KN<double> &u, const KN<double> &u_p, const  vector<double> & steps_p, const  vector<double> & nodes_p,
		 const  vector<double> & steps, const  vector<double> & nodes);
  void build_rhs_verbose(KN<double> &u, const KN<double> &u_p, const  vector<double> & steps_p, const  vector<double> & nodes_p,
		 const  vector<double> & steps, const  vector<double> & nodes);

  void build_rhs_same_grid(KN<double> &u, const KN<double> &u_p, const  vector<double> & steps_p, const  vector<double> & nodes_p,
		 const  vector<double> & steps, const  vector<double> & nodes);

  double build_time_error_estimator(const KN<double> &u, const KN<double> &u_p, const  vector<double> & steps_p, const  vector<double> & nodes_p,
		 const  vector<double> & steps, const  vector<double> & nodes);
  double build_time_error_estimator_same_grid(const KN<double> &u, const KN<double> &u_p, const  vector<double> & steps_p, const  vector<double> & nodes_p,
		 const  vector<double> & steps, const  vector<double> & nodes);

  double build_time_error_estimator(int it, const  vector< KN<double> >& P);


  void build_S_estimator_1(const KN<double> &u, const KN<double> &u_p, const  vector<double> & steps_p, const  vector<double> & nodes_p,
					  const  vector<double> & steps, const  vector<double> & nodes, const double rt , const double dt, KN<double> &estim );
  void build_S_estimator_1(int it,  const vector< KN<double> >& P, vector< KN<double> >& estim);

  double build_global_S_estimator(int it, const KN<double>& estim,const  vector<double> & nodes);

  void Time_Step_Transp_BC(int it,  vector< KN<double> >& P,int verbose=0);
}
;
#endif 
